/*
 *-----------------------------------------------------------------------------
 *  FILE: kaede.h
 *
 *      Copyright(c) 1998 SEGA System R&D Dept.
 *
 *  PURPOSE:
 *
 *      MapleCuuvwb_
 *
 *  DESCRIPTION:
 *
 *  AUTHOR(S):
 *
 *      1998/3/25  S.Uchida Ver.1.00
 *
 *  MOD HISTORY:
 *      1998/4/23  S.Uchida Ver.1.01
 *                 EfoCX\̂ύX
 *      1998/4/27  S.Uchida Ver.1.02
 *                 ERlN^}Nǉ
 *      1998/5/1   S.Uchida Ver.1.03
 *                 ER[obN֐T|[g
 *                 EenumdefineɕύX
 *      1998/5/7   S.Uchida Ver.1.04
 *                 EMT[o[֐sC
 *                 E[gfoCXڑ`FbNÂ
 *-----------------------------------------------------------------------------
 */

#ifndef _KAEDE_H_
#define _KAEDE_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */

#include <sg_xpt.h>


/*
 * GLOBAL DEFINES/MACROS DEFINES
 */

/******** foCXő吔 ***************************************************/
#define KDD_DEV_MAX 24


/******** foCXԍ` *************************************************/
#define KDD_DEV_0      0                      /* foCX  0               */
#define KDD_DEV_1      1                      /* foCX  1               */
#define KDD_DEV_2      2                      /* foCX  2               */
#define KDD_DEV_3      3                      /* foCX  3               */
#define KDD_DEV_4      4                      /* foCX  4               */
#define KDD_DEV_5      5                      /* foCX  5               */
#define KDD_DEV_6      6                      /* foCX  6               */
#define KDD_DEV_7      7                      /* foCX  7               */
#define KDD_DEV_8      8                      /* foCX  8               */
#define KDD_DEV_9      9                      /* foCX  9               */
#define KDD_DEV_10    10                      /* foCX  10              */
#define KDD_DEV_11    11                      /* foCX  11              */
#define KDD_DEV_12    12                      /* foCX  12              */
#define KDD_DEV_13    13                      /* foCX  13              */
#define KDD_DEV_14    14                      /* foCX  14              */
#define KDD_DEV_15    15                      /* foCX  15              */
#define KDD_DEV_16    16                      /* foCX  16              */
#define KDD_DEV_17    17                      /* foCX  17              */
#define KDD_DEV_18    18                      /* foCX  18              */
#define KDD_DEV_19    19                      /* foCX  19              */
#define KDD_DEV_20    20                      /* foCX  20              */
#define KDD_DEV_21    21                      /* foCX  21              */
#define KDD_DEV_22    22                      /* foCX  22              */
#define KDD_DEV_23    23                      /* foCX  23              */

#define KDD_DEV_A0     0                      /* foCX  0               */
#define KDD_DEV_A1     1                      /* foCX  1               */
#define KDD_DEV_A2     2                      /* foCX  2               */
#define KDD_DEV_A3     3                      /* foCX  3               */
#define KDD_DEV_A4     4                      /* foCX  4               */
#define KDD_DEV_A5     5                      /* foCX  5               */
#define KDD_DEV_B0     6                      /* foCX  6               */
#define KDD_DEV_B1     7                      /* foCX  7               */
#define KDD_DEV_B2     8                      /* foCX  8               */
#define KDD_DEV_B3     9                      /* foCX  9               */
#define KDD_DEV_B4    10                      /* foCX  10              */
#define KDD_DEV_B5    11                      /* foCX  11              */
#define KDD_DEV_C0    12                      /* foCX  12              */
#define KDD_DEV_C1    13                      /* foCX  13              */
#define KDD_DEV_C2    14                      /* foCX  14              */
#define KDD_DEV_C3    15                      /* foCX  15              */
#define KDD_DEV_C4    16                      /* foCX  16              */
#define KDD_DEV_C5    17                      /* foCX  17              */
#define KDD_DEV_D0    18                      /* foCX  18              */
#define KDD_DEV_D1    19                      /* foCX  19              */
#define KDD_DEV_D2    20                      /* foCX  20              */
#define KDD_DEV_D3    21                      /* foCX  21              */
#define KDD_DEV_D4    22                      /* foCX  22              */
#define KDD_DEV_D5    23                      /* foCX  23              */

/******** |[gԍ` ***************************************************/
#define KDD_PORT_A    0                       /* |[gA                   */
#define KDD_PORT_B    1                       /* |[gB                   */
#define KDD_PORT_C    2                       /* |[gC                   */
#define KDD_PORT_D    3                       /* |[gD                   */

/******** t@NV` ***********************************************/
#define KDD_FUNC_CONTROLLER     0x00000001  /* WRg[            */
#define KDD_FUNC_STORAGE        0x00000002  /* Xg[W                  */
#define KDD_FUNC_LCD            0x00000004  /* LCD                         */
#define KDD_FUNC_TIMER          0x00000008  /* ^C}                      */
#define KDD_FUNC_SOUNDINPUT     0x00000010  /*                     */
#define KDD_FUNC_ARGUN          0x00000020  /* AR-Gun                      */
#define KDD_FUNC_KEYBOARD       0x00000040  /* L[{[h                  */
#define KDD_FUNC_FFB            0x00000080  /* FFB()                     */

/******** X|XR[h *************************************************/
#define KDD_RES_DEVICESTATUS       0x05   /* Device Status                 */
#define KDD_RES_DEVICEALLSTATUS    0x06   /* Device All Status             */
#define KDD_RES_DEVICEREPLY        0x07   /* Device Reply                  */
#define KDD_RES_DATATRANSFER       0x08   /* Data Transfer                 */
#define KDD_RES_NORESPONSE         0xff   /* Ȃ                      */
#define KDD_RES_FUNCTIONUNKNOWN    0xfe   /* Function Type Unknown         */
#define KDD_RES_COMMANDUNKNOWN     0xfd   /* Command Unknown               */
#define KDD_RES_TRANSMITAGAIN      0xfc   /* Transmit Again                */
#define KDD_RES_FILEERROR          0xfb   /* File Error                    */
#define KDD_RES_LCDERROR           0xfa   /* LCD Error                     */
#define KDD_RES_ARERROR            0xf9   /* AR Error                      */

/******** t@NVG[R[h ***************************************/
#define KDD_ERR_OK            0           /* G[Ȃ                    */
#define KDD_ERR_PARTITION     (1 << 0)    /* p[eBVG[          */
#define KDD_ERR_PHASE         (1 << 1)    /* tFCYG[                */
#define KDD_ERR_BLOCK         (1 << 2)    /* ubNG[                */
#define KDD_ERR_WRITE         (1 << 3)    /* CgG[                  */
#define KDD_ERR_LENGTH        (1 << 4)    /* f[^G[                */
#define KDD_ERR_CRC           (1 << 5)    /* CRCG[                     */

/******** GAR[h *****************************************************/
#define KDD_AREA_USA          (1 << 0)    /* kAJn                */
#define KDD_AREA_JAPAN        (1 << 1)    /* {n                      */
#define KDD_AREA_ASIA         (1 << 2)    /* AWAn                    */
#define KDD_AREA_EUROPE       (1 << 3)    /* [bpn                */
#define KDD_AREA_RESERVED1    (1 << 4)    /* \n1                     */
#define KDD_AREA_RESERVED2    (1 << 5)    /* \n2                     */
#define KDD_AREA_RESERVED3    (1 << 6)    /* \n3                     */
#define KDD_AREA_RESERVED4    (1 << 7)    /* \n4                     */

/******** RlN^ڑ *************************************************/
#define KDD_CONDIR_TOPSIDE      0         /*                             */
#define KDD_CONDIR_BOTTOMSIDE   1         /*                             */
#define KDD_CONDIR_LEFTSIDE     2         /*                             */
#define KDD_CONDIR_RIGHTSIDE    3         /* E                            */

/******** [h^Cv萔 *************************************************/
#define KDD_MODE_OPTIMIZE    0            /* œK[h                  */
#define KDD_MODE_NOPCOUNT    1            /* NOP}                   */
#define KDD_MODE_TIMEOUT     2            /* ^CAEg܂ł̎        */
#define KDD_MODE_SPEED       3            /* ʐMx                      */
#define KDD_MODE_DREQCOUNT   4            /* gfoCXւDev.Req.  */
#define KDD_MODE_DEVENDIAN   5            /* foCXGfBA          */
#define KDD_MODE_DEBUG       6            /* fobO[h                */
#define KDD_MODE_ROOTPLAY    7            /* ROOTfoCXT.O.e      */

/******** œK[h *****************************************************/
#define KDD_OPTIMIZE_NONE   0             /* œKȂ                    */
#define KDD_OPTIMIZE_8MS    1             /* VBlank InO8msŊJn        */
#define KDD_OPTIMIZE_4MS    2             /* VBlank InO4msŊJn        */
#define KDD_OPTIMIZE_2MS    3             /* VBlank InO2msŊJn        */
#define KDD_OPTIMIZE_1MS    4             /* VBlank InO1msŊJn        */

/******** ʐMx *********************************************************/
#define KDD_SPEED_2MBPS   0x00000000      /* 2MBPS                         */
#define KDD_SPEED_1MBPS   0x00000100      /* 1MBPS                         */
#define KDD_SPEED_4MBPS   0x00000200      /* 4MBPS                         */
#define KDD_SPEED_8MBPS   0x00000300      /* 8MBPS                         */

/******** foCXGfBA *********************************************/
#define KDD_DEVENDIAN_LITTLE   0          /* gGfBA            */
#define KDD_DEVENDIAN_BIG      1          /* rbOGfBA            */

/******** fobO *********************************************************/
#define KDD_DEBUG_OFF   0                 /* fobOOFF                   */
#define KDD_DEBUG_ON    1                 /* fobOON                    */

/******** |[gǗ\ *************************************************/
typedef struct {
	Uint8 lmon;                 /* ڑԃrbg                      */
	Uint8 lmold;                /* Ot[ł̕ڑԃrbg        */
	Uint8 lmcon;                /* ڑ OFF->ON ωrbg         */
	Uint8 lmremv;               /* ڑ ON->OFF ωrbg         */
	Uint32 playcount;           /* \                                    */
} KDS_PORT;

/******** foCXǗ\ ***********************************************/
typedef struct {
	Uint8 on;                   /* _ڑԃtO                      */
	Uint8 old;                  /* Ot[ł̘_ڑ              */
	Uint8 connect;              /* _ڑ OFF->ONωtO          */
	Uint8 remove;               /* _ڑ ON->OFFωtO          */
	Uint8 response;             /* X|XR[h                        */
	Uint8 dst_ap;               /* ]AP                                */
	Uint8 src_ap;               /* ]AP                                */
	Uint8 datasize;             /* f[^TCY(O[h)            */
	void* recvdata;             /* Mf[^̃AhX                    */
	Sint32 errcode;             /* t@NVG[R[h              */
	Uint32 reserved[2];         /* \                                    */
} KDS_DEVICE;

/******** foCX\ ***********************************************/
typedef struct {
	Uint32 function;            /* t@NV                          */
	Uint8 fd[3][4];             /* t@NV`ubNf[^        */
	Uint8 is_root;              /* [gfoCXǂ\            */
	Uint8 area_code;            /* GAR[h                            */
	Uint8 connector_dir[2];     /* gRlN^                        */
	char product_name[32];      /* i                                  */
	char license[64];           /* CZX                              */
	Uint16 stdby_pow;           /* X^oCd                      */
	Uint16 max_pow;             /* őd                            */
} KDS_DEVICEINFO;

/******** Rg[\ *******************************************/
typedef struct {
	Uint32 button;              /* Ă{^                        */
} KDS_CONTROLLERINFO;

/******** LCD\ ****************************************************/
#define KDD_LCD_NORMALLYWHITE 0 /* Normally White                          */
#define KDD_LCD_NORMALLYBLACK 1 /* Normally Black                          */
#define KDD_LCD_HV_00         0 /* f[^т̓^Cv'00'                  */
#define KDD_LCD_HV_01         1 /* f[^т̓^Cv'01'                  */
#define KDD_LCD_HV_10         2 /* f[^т̓^Cv'10'                  */
#define KDD_LCD_HV_11         3 /* f[^т̓^Cv'11'                  */

typedef struct {
	Uint16 partition;           /* p[eBV                        */
	Uint16 blocksize;           /* 1ubÑoCg                     */
	Uint16 writecount;          /* 1ubNCg                     */
	Uint8  direction;           /* sNZ̕H/V                       */
	Uint8  normally;            /* Normally Black/White                    */
} KDS_LCDINFO;

/******** Xg[W\ *********************************************/
#define KDD_STORAGE_REMOVABLE 1 /* [oufBAł              */

typedef struct {
	Uint16 partition;           /* p[eBV                        */
	Uint16 blocksize;           /* 1ubÑoCg                     */
	Uint16 writecount;          /* 1ubNCg                     */
	Uint16 readcount;           /* 1ubN[h                     */
	Uint16 removable;           /* [oufBAǂ            */
	Uint16 reserved;            /* \                                    */
} KDS_STORAGEINFO;

/******** ^C}\ *************************************************/
typedef struct {
	Uint8 write_timer;          /* ݉\^C}                      */
	Uint8 read_timer;           /* ǂݍ݉\^C}                      */
	Uint8 button;               /* Ă{^                        */
	Uint8 alarm;                /* ĂA[                      */
} KDS_TIMERINFO;

/******** SIP\ ****************************************************/
#define KDD_SIP_GETSAMPLINGDATA 1 /* Get Sampling DataTuR}h   */
#define KDD_SIP_BASICCONTROL    2 /* Basic ControlTuR}h       */
#define KDD_SIP_AMPCONTROL      4 /* AMP ControlTuR}h         */
#define KDD_SIP_TESTMODE        8 /* Test ModeTuR}h           */

typedef struct {
	Uint32 function;            /* Ă@\                          */
} KDS_SIPINFO;

/******** GUN\ ***************************************************/
typedef struct {
	Uint32 button;              /* Ă{^                        */
} KDS_GUNINFO;


/******** vg^Cv *****************************************************/

/*------- VXe֐ ----------------------------------------------------*/
Sint32 kdInitSystem(void* senduf, void* recvbuf);
void kdExitSystem(void);

/*------- t[֐ ----------------------------------------------------*/
Sint32 kdMakeFrame(void);
Sint32 kdSendFrame(void);
Sint32 kdRecvFrame(void);

/*------- [hݒ֐ --------------------------------------------------*/
Sint32 kdSetDriverMode(Sint32 type, Sint32 mode);
Sint32 kdGetDriverMode(Sint32 type);

/*------- foCXǗ֐ ------------------------------------------------*/
const KDS_DEVICE* kdGetDevice(Sint32 device);
const KDS_DEVICEINFO* kdGetDeviceInfo(Sint32 device);
const KDS_PORT* kdGetPortStatus(Sint32 port);
Sint32 kdGetStatus(Sint32 device, Sint32 seq);
Sint32 kdIsChanged(Sint32 device);
void kdRecognizeChanged(Sint32 device);

/*------- R}hs֐ ------------------------------------------------*/
Sint32 kdSetDeviceRequest(Sint32 device);
Sint32 kdSetAllStatusRequest(Sint32 device);
Sint32 kdSetDeviceReset(Sint32 device);
Sint32 kdSetDeviceKill(Sint32 device);
Sint32 kdSetGetCondition(Sint32 device, Sint32 func);
Sint32 kdSetGetMediaInfo(Sint32 device, Sint32 func, Sint32 pt);
Sint32 kdSetBlockRead(Sint32 device, Sint32 func, Sint32 pt,
											Sint32 phase, Sint32 block);
Sint32 kdSetBlockWrite(Sint32 device, Sint32 func, Sint32 pt,
					Sint32 phase, Sint32 block, const void* src, Sint32 size);
Sint32 kdSetGetLastError(Sint32 device, Sint32 func, Sint32 pt,
											Sint32 phase, Sint32 block);
Sint32 kdSetARControl(Sint32 device, const void* buf);
Sint32 kdSetFT4Control(Sint32 device, const void* buf);
Sint32 kdSetSetCondition(Sint32 device, Sint32 func, const void* buf,
																Sint32 size);
Sint32 kdSetTransmitAgain(Sint32 device);
Sint32 kdSetResetPattern(Sint32 port);

/*------- foCXT[rX֐ --------------------------------------------*/
const Uint8* kdDevGetFD(const KDS_DEVICEINFO* dev, Uint32 func);
Sint32 kdDevGetControllerInfo(KDS_CONTROLLERINFO* sinfo,
											const KDS_DEVICEINFO* info);
Sint32 kdDevGetStorageInfo(KDS_STORAGEINFO* sinfo,
											const KDS_DEVICEINFO* info);
Sint32 kdDevGetSIPInfo(KDS_SIPINFO* sinfo, const KDS_DEVICEINFO* info);
Sint32 kdDevGetLCDInfo(KDS_LCDINFO* sinfo, const KDS_DEVICEINFO* info);
Sint32 kdDevGetTimerInfo(KDS_TIMERINFO* sinfo, const KDS_DEVICEINFO* info);
Sint32 kdDevGetGunInfo(KDS_GUNINFO* sinfo, const KDS_DEVICEINFO* info);

/*------- ̑̊֐ ----------------------------------------------------*/
void kdGetVersion(Sint32* major, Sint32* minor);

/*------- R}hs֐(R[obNt) ------------------------------*/
typedef void (*KD_CALLBACK)(Sint32 device, Sint32 seqno,
								KDS_DEVICE* dev, KDS_DEVICEINFO* info);
Sint32 kdSetCallback(Sint32 device, KD_CALLBACK func, Sint32 seqno);
Sint32 kdSetDeviceRequestEx(Sint32 device, KD_CALLBACK cbfunc);
Sint32 kdSetAllStatusRequestEx(Sint32 device, KD_CALLBACK cbfunc);
Sint32 kdSetDeviceResetEx(Sint32 device, KD_CALLBACK cbfunc);
Sint32 kdSetDeviceKillEx(Sint32 device, KD_CALLBACK cbfunc);
Sint32 kdSetGetConditionEx(Sint32 device, Sint32 func, KD_CALLBACK cbfunc);
Sint32 kdSetGetMediaInfoEx(Sint32 device, Sint32 func, Sint32 pt,
														KD_CALLBACK cbfunc);
Sint32 kdSetBlockReadEx(Sint32 device, Sint32 func, Sint32 pt,
							Sint32 phase, Sint32 block, KD_CALLBACK cbfunc);
Sint32 kdSetBlockWriteEx(Sint32 device, Sint32 func, Sint32 pt, Sint32 phase,
			Sint32 block, const void* src, Sint32 size, KD_CALLBACK cbfunc);
Sint32 kdSetGetLastErrorEx(Sint32 device, Sint32 func, Sint32 pt,
							Sint32 phase, Sint32 block, KD_CALLBACK cbfunc);
Sint32 kdSetARControlEx(Sint32 device, const void* buf, KD_CALLBACK cbfunc);
Sint32 kdSetFT4ControlEx(Sint32 device, const void* buf, KD_CALLBACK cbfunc);
Sint32 kdSetSetConditionEx(Sint32 device, Sint32 func, const void* buf,
											Sint32 size, KD_CALLBACK cbfunc);
Sint32 kdSetTransmitAgainEx(Sint32 device, KD_CALLBACK cbfunc);
Sint32 kdSetResetPatternEx(Sint32 port, KD_CALLBACK cbfunc);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _KAEDE_H_ */

/******************************* end of file *******************************/
