/*
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *  
 *       Memory Management
 *
 *  Module  : Library Header File
 *  File    : sg_Maloc.h
 *  Create  : 1998-03-25
 *  Modify  :
 *  Version : 1.00
 *  Note    :
 */

#ifndef _SG_MALOC_H_
#define _SG_MALOC_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

Void syMallocInit(Void *heap, Uint32 size);

Void syMallocFinish(Void);

Void *syMalloc(Uint32 nbytes);

Void syFree(Void *ap);

char *sbrk(unsigned long);
#ifdef __cplusplus
	   }
#endif /* __cplusplus */

#endif /* _SG_MALOC_H_ */

/******************************* end of file *******************************/
