/**********************************************************************

	Title :			Debug Module 
	Filename :		debug.c
	Author :		Thomas Szirtes
	Revision :		1.0

	Notes :			Debug

	Copyright :		(C) SEGA Europe 1998

  **********************************************************************/


#include	"ftypes.h"

#ifdef USING_SET4
#include	"shinobi.h"
#else
#include	"ninja.h"
#endif


/* ------------------ SET 4 DEBUG --------------------*/
#ifdef USING_SET4

void DEBUG_Init	( void )
{

}


void DEBUG_ErrorS ( char *string )
{
}

#else

#include	"ninjawin.h"

/* ------------------ SET 2 DEBUG ---------------------*/

void DEBUG_Init	( void )
{
	HWND	dhwnd;

	dhwnd	=	CreateWindow("debug",
							NULL,
							WS_CHILD|WS_VISIBLE|WS_HSCROLL|WS_VSCROLL|WS_BORDER|
							ES_LEFT|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL,
							0, 0, 640, 480, 
							(HWND)njGetWindowHandle(),
							(HMENU) 1, 
							(HINSTANCE)njGetInstance(),
							NULL);

	ShowWindow(dhwnd,SW_SHOW);
							

}


void DEBUG_ErrorS ( char *string )
{
	printf("ERROR : %s\n",string);
}

#endif