/**********************************************************************

	Title :                 MODELS
	Filename :              f_model.c
	Author :                Thomas Szirtes
	Revision :              1.0

	Notes :                 

	Copyright :             (C) SEGA Europe 1998

  **********************************************************************/

#define       USING_SET4

#ifdef USING_SET4
 #include        "shinobi.h"
#else
 #include        <ninja.h>
#endif

#include        "NjDef.h"
  
#ifdef USING_SET4

#include "pvrmodel\A.nja"
#include "pvrmodel\B.nja"
#include "pvrmodel\C.nja"
#include "pvrmodel\D.nja"
#include "pvrmodel\E.nja"
#include "pvrmodel\F.nja"
#include "pvrmodel\G.nja"
#include "pvrmodel\H.nja"
#include "pvrmodel\I.nja"
#include "pvrmodel\J.nja"
#include "pvrmodel\K.nja"
#include "pvrmodel\L.nja"
#include "pvrmodel\M.nja"
#include "pvrmodel\N.nja"
#include "pvrmodel\metal1.nja"
#include "pvrmodel\metal2.nja"
#include "pvrmodel\metal3.nja"
#include "pvrmodel\chimney.nja"
#include "pvrmodel\shield.nja"
#include "pvrmodel\main.nja"
#include "pvrmodel\shiphi4.nja"
#include "pvrmodel\shiphi5.nja"
#include "pvrmodel\shiphi3.nja"
#include "pvrmodel\tests.nja"
#include "pvrmodel\exsphere.nja"
#include "pvrmodel\sky.nja"
#include "clsn\M.cln"
#include "clsn\L.cln"
#include "clsn\K.cln"
#include "clsn\B.cln"
#include "clsn\C.cln" 
      

#else


#include "d:\future\data\model\A.nja"
#include "d:\future\data\model\B.nja"
#include "d:\future\data\model\C.nja"
#include "d:\future\data\model\D.nja"
#include "d:\future\data\model\E.nja"
#include "d:\future\data\model\F.nja"
#include "d:\future\data\model\G.nja"
#include "d:\future\data\model\H.nja"
#include "d:\future\data\model\I.nja"
#include "d:\future\data\model\J.nja"
#include "d:\future\data\model\K.nja"
#include "d:\future\data\model\L.nja"
#include "d:\future\data\model\M.nja"
#include "d:\future\data\model\N.nja"
#include "d:\future\data\model\metal1.nja"
#include "d:\future\data\model\metal2.nja"
#include "d:\future\data\model\metal3.nja"
#include "d:\future\data\model\chimney.nja"
#include "d:\future\data\model\shield.nja"
#include "d:\future\data\model\main.nja"
#include "d:\future\data\model\shiphi4.nja"
#include "d:\future\data\model\shiphi5.nja"
#include "d:\future\data\model\shiphi3.nja"
#include "d:\future\data\model\tests.nja"
#include "d:\future\data\model\exsphere.nja"
#include "d:\future\data\model\sky.nja"
#include "d:\future\data\clsn\M.cln"
#include "d:\future\data\clsn\L.cln"
#include "d:\future\data\clsn\K.cln"
#include "d:\future\data\clsn\B.cln"
#include "d:\future\data\clsn\C.cln" 


#endif
