/****************************************************
 *													*
 *	Katana G2 Library								*
 *			Library Development Kit					*
 *													*
 *			Copyright 1998 (C)SEGA Enterprises		*
 *			Programmed By T.Jokagi					*
 *													*
 ****************************************************/

#ifndef	SYD_G2_H
#define	SYD_G2_H	1

#include	<sg_xpt.h>

enum SYE_G2_DATA_WIDTH
{
	SYE_G2_DATA_WIDTH_8BIT	= 0x01,		/*	f[^͂Wrbg  */
	SYE_G2_DATA_WIDTH_16BIT	= 0x02,		/*	f[^16rbg  */
	SYE_G2_DATA_WIDTH_32BIT	= 0x04		/*	f[^32rbg  */
};
typedef enum SYE_G2_DATA_WIDTH	SYE_G2_DATA_WIDTH;

enum SYE_G2_ADR_MODE
{
	SYE_G2_ADR_MODE_FIX,	/*	AhXŒ  */
	SYE_G2_ADR_MODE_ADD		/*	AhXZ  */
};
typedef enum SYE_G2_ADR_MODE	SYE_G2_ADR_MODE;

EXTERN Void syG2Read( Void *g2_adr, Void *buf_ptr, SYE_G2_DATA_WIDTH data_width, Sint32 data_num, SYE_G2_ADR_MODE src_mode,  SYE_G2_ADR_MODE dst_mode);
EXTERN Void syG2Write( Void *buf_ptr, Void *g2_adr, SYE_G2_DATA_WIDTH data_width, Sint32 data_num, SYE_G2_ADR_MODE src_mode,  SYE_G2_ADR_MODE dst_mode);

#endif	/*	#ifndef	SYD_G2_H  */
