/*
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *  
 *       SH4 Timer 
 *
 *  Module  : Library Header File
 *  File    : sg_tmr.h
 *  Create  : 1998-03-03
 *  Modify  : 1998-05-12
 *  Version : 0.43
 *  Note    :
 */


#ifndef _SG_TMU_H_
#define _SG_TMU_H_


#include <sg_sytmr.h>


/******* JE^NbNwԍ` **************************************/
#define SYD_TMR_CLOCK_P4        (0)         /* P/4                       */
#define SYD_TMR_CLOCK_P16       (1)         /* P/16                      */
#define SYD_TMR_CLOCK_P64       (2)         /* P/64                      */
#define SYD_TMR_CLOCK_P256      (3)         /* P/256                     */
#define SYD_TMR_CLOCK_P1024     (4)         /* P/1024                    */
typedef Uint16 SY_TMR_CLOCK;

/******* G[R[h ******************************************************/
#define SYD_TMR_ERR_OK          (0)         /* G[Ȃ                  */
#define SYD_TMR_ERR_EXIST       (-1)        /* ɓo^Ă          */

/******* ֐vg^Cv **************************************************/
/*------- t[^C}֐ -------*/
void syTmrSetClock(SY_TMR_CLOCK);

/*------- ^C}1֐ -------*/
Sint32 syTmrInt1Set(Uint32, void(*)(void *), void *);
void syTmrInt1Cancel(void);
Sint32 syTmrInt1SetEx(Uint32, void(*)(void *), void *, SY_TMR_CLOCK);

/*------- ^C}2֐ -------*/
Sint32 syTmrInt2Set(Uint32, void(*)(void *), void *);
void syTmrInt2Cancel(void);
Sint32 syTmrInt2SetEx(Uint32, void(*)(void *), void *, SY_TMR_CLOCK);


#endif /* _SG_TMU_H_ */

/******************************* end of file *******************************/
